#include <sys/types.h>
#include <stdio.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/param.h>
#include <sys/socket.h>
#include <sys/file.h>
#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netdb.h>

#define PORTNUMBER2  23
#define PORTNUMBER1  9900
#define MAXHOSTNAME 80
void reusePort(int sock);   

int sockList[64], lastSock=0, i, j, tmp, marca=0, nuevo=0;
char buf96[64]="se retira el cliente del enlace:", buf97[64]="numero de current client:";
char buf99[512]="Se incorporo un nuevo usuario a la secion Telnet\n se le asigno el enlace :  ", buf98[64]="\n";
char buf90[512]="\n--------------------------------------------------------------\n";
char mensage[1024], mensage2[1024], mensage3[1024];
struct  hostent *hp;
//varibles para grupo mcast
   int   s4;
   struct   sockaddr_in mc_group4;
   struct sockaddr_in addr4;
   unsigned long int GroupIP4;
   /* Solaris
      in_addr_t GroupIP; */
   char loop, ttl;

main( argc, argv )
int argc;
char *argv[];
{
//variables para servidor del cli
  int   s;
  struct sockaddr_in server;
  struct sockaddr_in from;
  int fromlen;
  int length;
  fd_set readfds, readfdsCopy, readfds2, readfds2Copy;
  int n;

//variables para cli  del telnet real
int n2=0, s2, len2;
char buf2[1024];
char hostname2[64];
struct hostent *hp2;
struct sockaddr_in name2;

// hecho grupo mcast                        ///*nuevo1
if (argc != 4) {
     fprintf(stderr, "Usage : %s <port Telnet> <multicast group> <port Mcast>\n",argv[0]);
     exit(0);
   }
if( (GroupIP4 = inet_addr(argv[2]))== -1)      //IPgrup
       printf("error in inet_addr\n");

   mc_group4.sin_family = AF_INET;
   mc_group4.sin_port = htons(atoi(argv[3]));     //purto mcast
   mc_group4.sin_addr.s_addr = GroupIP4;

   s4 = socket (PF_INET,SOCK_DGRAM,0);
   reusePort(s4);

   loop = 1;
   if( setsockopt(s4,IPPROTO_IP,IP_MULTICAST_LOOP,(char *) &loop,
		  sizeof(u_char)) == -1 )
   {
     printf("error in setting loopback\n");
   }

    ttl = 0;
   if( setsockopt(s4,IPPROTO_IP,IP_MULTICAST_TTL,(char *) &ttl,
		  sizeof(u_char)) == -1 )
   {
     printf("error in setting loopback value\n");
   }
                                            //fin nuevo1*/

//cli   del telnet (confg. comunic. con telnet real)
  /* Get our local host name.*/
    gethostname(hostname2, sizeof(hostname2));
 printf("host is: %s\n", hostname2);
    /* Look up our host's network address.*/
    hp2 = gethostbyname(hostname2);

    /* Create a socket in the INET domain.*/
    s2 = socket(AF_INET, SOCK_STREAM, 0);

    //libera el socket si antes estaba usado
    reusePort(s2);

    /* Create the address of the server. */
    name2.sin_family = AF_INET;
    name2.sin_port = htons(PORTNUMBER2);
    memcpy(&name2.sin_addr, hp2->h_addr_list[0], hp2->h_length);
    len2 = sizeof(struct sockaddr_in);


//ser de cli (confg. comunic. con cli's)

  /* Construct name of socket to send to. */
  server.sin_family = AF_INET;
  server.sin_addr.s_addr = INADDR_ANY;
  server.sin_port = htons(atoi(argv[1])); // asigna pueto cli telnet
                            			

  s = socket (AF_INET,SOCK_STREAM,0); 
  reusePort(s);

  if ( bind( s, (struct sockaddr *)&server, sizeof(server) ) ) {
    close(s); //bind asocia soket con una puerta asi cli acede
    perror("binding name to stream socket1");
    exit(-1);
  }

  length = sizeof(server);
  if ( getsockname (s, (struct sockaddr *)&server,&length) ) {
    perror("getting socket name");
    exit(0);
  }

  printf("Telnet Server Port is: %d\n", ntohs(server.sin_port));
  printf("MultiCast Grup is: %s\n", argv[2]);
  printf("Multicast Port is: %d\n", ntohs(mc_group4.sin_port));


  listen(s,4);
  fromlen = sizeof(from);
  FD_ZERO(&readfdsCopy);
  FD_SET(s2,&readfdsCopy);
  FD_SET(s,&readfdsCopy);

// cuerpo principal
//** espera actividad de un cli serv telnet, atiende y retransmite.**
  for(;;){
    memcpy(&readfds, &readfdsCopy, sizeof(fd_set));
    n = select(FD_SETSIZE, &readfds, (fd_set *) 0, (fd_set *) 0, NULL);

    if (n > 0) {	//si hay actividad atiende
      if (FD_ISSET(s, &readfds)) {	//inicia coneccion con cli
	printf("\n  -***- Accepting a new connection... -***- \n");
        marca++;
	if (lastSock==0){	//si es el 1er cli. inicia sesion con telnet
           printf("1era peticion de telnet...\n");
	   connect(s2, (struct sockaddr *) &name2, len2);
	   lastSock++;	
	   FD_SET(s2, &readfdsCopy);	
	}

	sockList[lastSock++] = accept(s, (struct sockaddr *)&from, &fromlen);
	printf("form cli: %d\n",sockList[lastSock-1] );
	FD_SET(sockList[lastSock-1], &readfdsCopy);
 
 	//datos de computadores en conectecion
 	printf("Connected to TCP/fdo(cli o ser??):");
 	printf("%s:%d\n", inet_ntoa(name2.sin_addr), ntohs(name2.sin_port)); //nme2=from
 	if ((hp = gethostbyaddr((void *)&name2.sin_addr.s_addr,
    	sizeof(name2.sin_addr.s_addr),AF_INET)) == NULL)
    	fprintf(stderr, "Can't find host %s\n", inet_ntoa(name2.sin_addr));
  	else
    	printf("(Name is : %s)\n", hp->h_name);

	/*envia mensaje de nuevo cli telnet a grupo multicast*/
            sprintf(mensage, "\n %s %d \n", buf99, sockList[lastSock-1]);
/**/        if (sendto(s4, mensage, sizeof(mensage), 0, (struct sockaddr*)&mc_group4,
		sizeof(mc_group4)) <0 )
	        perror("sending datagram message (mcast)");

    	if (marca>1){  	// aviso1 a todos los cli
		
         for(j=1; j < lastSock; j++){  //		******	1<--0
	   if (send(sockList[j], mensage, sizeof(mensage), 0) <0 ){
       		perror("sending stream message");printf("con cli: psd=%d\n",sockList[j]);
	   }
         }
	 if (send(s2, buf98,sizeof(buf98) , 0) <0 ){  //si hay paq. del telnet se retrans. a cli
       		perror("sending stream message");printf("con telnet\n");
      	 }		
        }
      }

      /*si hay actividad en telnet atiende y retransmite */
      if (FD_ISSET(s2, &readfds)){	
            tmp=EchoServe2(s2);	// Llamado a echoserver2
      }

      /*si hay actividad en algun cli atiende y retransmite al telnet*/
      for (i=1; i < lastSock; i++) {    //	****  1 <-- 0
	if (FD_ISSET(sockList[i], &readfds))    // **si hay paq. de cli retrans srv telnet**
	    if (EchoServe1(sockList[i],s2) < 0) {      //llamada a EchoServ1
	      FD_CLR(sockList[i], &readfdsCopy);
	      sockList[i] = sockList[--lastSock];
	      i--;
	      printf("Number of current clients: %d\n", (lastSock-1));  //aviso2
	sprintf(mensage2, "\n %s  %d \n %s %d \n", buf96, sockList[lastSock-1], buf97, (lastSock-1));

        for(j=1; j < lastSock; j++){  //		******	1<--0
	   if (send(sockList[j], mensage2, sizeof(mensage2), 0) <0 ){
       		perror("sending stream message");printf("con cli: psd=%d\n",sockList[j]);
	   }
        }
	/*publica mensaje de salida de un cli telnet*/	
        sprintf(mensage3, "\n %s  \n %s \n", mensage2, buf90);
/**/    if (sendto(s4, mensage3, sizeof(mensage3), 0, (struct sockaddr*)&mc_group4,
		sizeof(mc_group4)) <0 )
	        perror("sending datagram message (mcast)");

	if (send(s2, buf98,sizeof(buf98) , 0) <0 ){
       		perror("sending stream message");printf("con telnet\n");
      	}	
	marca--;
	if (lastSock==1){
		FD_CLR(sockList[0], &readfdsCopy);
		lastSock=0;
         	printf("fin de telnet...\n");
        }
	}
      }
    }

  }

  close (s4);
}
/*lee lo que dice el cli y retransmite al telnet*/
int EchoServe1(int psd, int ss)
{
  char buf[1024];
  int rc;

  /*  get data from  clients and send it back */
  for(;;){
    printf("\n...server is waiting from cli: %d...\n",psd);
    if( (rc=recv(psd, buf, sizeof(buf),0)) < 0)  //read??
     	 perror("receiving stream  message");
    if (rc > 0){
      buf[rc]=(char)NULL;			
      printf("Received from cli %d : %s\n",psd , buf);
      if (send(ss, buf, rc, 0) <0 ){ // envia bufer al telnet
       	perror("sending stream message");printf("con telnet\n");
      }

      return(1);
    }
    else {
      printf("Disconnected..\n");
      close (psd);
      return(-1);
    }
  }
}
/*recive desde el serv. telnet y retransmite a todos los cli
y publica al canal multicast*/
int EchoServe2(int ss)
{
  char buf[9600];
  int rc;

  /* get data from  clients and send it back */
  for(;;){
    printf("\n...server is waiting from telnet...\n");
    if( (rc=recv(ss, buf, sizeof(buf),0)) < 0)  //read from telnet
      		perror("receiving stream  message");
    if (rc > 0){
      for(i=1; i < lastSock; i++){  //		******	1<--0
	if (send(sockList[i], buf, rc, 0) <0 ){	//sent to clis
       	perror("sending stream message");printf("con cli: psd=%d\n",sockList[i]);
	}
      }
      buf[rc]='\0';//(char)NULL;			//cast fdo

/**/  /* publica a canal multicast*/                                    //*nuevo
      if (sendto(s4, buf, rc, 0, (struct sockaddr*)&mc_group4,
		sizeof(mc_group4)) <0 )
	 perror("sending datagram message (mcast)");
									//fin nuevo*/
      printf("Received from telnet: %s \n", buf);
      return(1);
    }
    else {
      printf("Disconnected.telnet.\n");
      //close (psd);
      return(-1);
    }
  }
}
//permite liberar puerta si previamente no liberada
void reusePort(int s)
{
  int one=1;

  if ( setsockopt(s,SOL_SOCKET,SO_REUSEADDR,(char *) &one,sizeof(one)) == -1 )
  {
    printf("error in setsockopt,SO_REUSEPORT \n");
    exit(-1);
  }
}      
